// Copyright 2020 The klaytn Authors
// This file is part of the klaytn library.
//
// The klaytn library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// The klaytn library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with the klaytn library. If not, see <http://www.gnu.org/licenses/>.

/*
Package bridgepool implements a pool of transactions generated by RemoteBackend.

Source files

Each file provides the following features.
  - bridge_tx_journal.go : logs transactions generated by SubBridge to allow non-executed ones to survive node restarts.
  - bridge_tx_pool.go : contains transactions generated by SendTransaction function of RemoteBackend.
  - sorted_map_list.go : implements a nonce-sorted item maps.
*/
package bridgepool
